//*****************************************************************************************************
//  1. t@C
//		RealtimeData.cpp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		A^C\NX̎
//----------------------------------------------------------------------------------------------------
//  3. l
//----------------------------------------------------------------------------------------------------
//  4. 
//		2008.12.01 S.Aizawa VK쐬
//*****************************************************************************************************

#include "StdAfx.h"
#include "MMA_G.h"
#include "RealtimeData.h"
#include "GlobalData.h"
#include "Define.h"
#include "General.h"
#include "BinFile.h"
#include "DataFile.h"
#include "CalcFile.h"
#include "RsuTaaTbl.h"
#include <shlwapi.h>

// define`
#define CYCLE_TIME	1000		// A^Cf[^Ď
#define BIN_HEADER_SIZE	44		// oCit@Cwb_TCY

// f[^intɕϊ}N
#define	GetAd(x) ((*(BYTE *)(x) << 16) | *(BYTE *)((x) + 1) << 8 | *(BYTE *)((x) + 2))

// f[^
#define LOSS_DATA	-1

// bint@CړtH_
#define	OLD_BIN_FILE	"OLD_BIN_FILE"

// A^C\NX̃CX^X
CRealtimeData g_RealtimeData;

// RSU_IDTAA_ID̑Ήe[u
static CRsuTaaTbl g_RsuTaaTbl;

//*****************************************************************************************************
//  1. ֐
//		CRealtimeBinFile::CRealtimeBinFile
//----------------------------------------------------------------------------------------------------
//  2. @\
//		oCit@CNX̃RXgN^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
CRealtimeBinFile::CRealtimeBinFile()
{
	m_nBinDataSize = 0;
}

//*****************************************************************************************************
//  1. ֐
//		CRealtimeBinData::CRealtimeBinData
//----------------------------------------------------------------------------------------------------
//  2. @\
//		oCif[^NX̃RXgN^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
CRealtimeBinData::CRealtimeBinData()
{
	m_pBinBuf = NULL;
}

//*****************************************************************************************************
//  1. ֐
//		CRealtimeBinData::~CRealtimeBinData
//----------------------------------------------------------------------------------------------------
//  2. @\
//		oCif[^NX̃fXgN^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
CRealtimeBinData::~CRealtimeBinData()
{
	// t@Cǂݍ݃obt@
	FreeBuf();
}

//*****************************************************************************************************
//  1. ֐
//		CRealtimeBinData::FreeBuf
//----------------------------------------------------------------------------------------------------
//  2. @\
//		oCif[^ǂݍ݃obt@
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CRealtimeBinData::FreeBuf()
{
	// t@Cǂݍ݃obt@
	if (m_pBinBuf != NULL) {
		delete [] m_pBinBuf;
		m_pBinBuf = NULL;
	}
}

//*****************************************************************************************************
//  1. ֐
//		CRealtimeBinData::GetBinDataSize
//----------------------------------------------------------------------------------------------------
//  2. @\
//		oCif[^TCY擾
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		int		f[^TCY
//*****************************************************************************************************
int CRealtimeBinData::GetBinDataSize()
{
	int nDataSize = 0;

	if (m_aBinFile.GetSize() != 0) {
		int nLastIndex = (int)m_aBinFile.GetSize() - 1;
		nDataSize = m_aBinFile[nLastIndex].m_nBinDataOffset + m_aBinFile[nLastIndex].m_nBinDataSize;
	}

	return nDataSize;
}

//*****************************************************************************************************
//  1. ֐
//		CRealtimeBinData::SeekBinFile
//----------------------------------------------------------------------------------------------------
//  2. @\
//		oCif[^t@Cw肳ꂽʒuɃV[N
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		int		nSeekSize		[I] V[Nʒu
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CRealtimeBinData::SeekBinFile(int nSeekSize)
{
	// V[NʒũoCit@C߂
	m_nBinFileIndex = 0;
	int nOffset;
	while (true) {
		nOffset = nSeekSize - m_aBinFile[m_nBinFileIndex].m_nBinDataOffset;
		if (nOffset >= m_aBinFile[m_nBinFileIndex].m_nBinDataSize)
			m_nBinFileIndex++;
		else
			break;
	}

	// oCit@Cobt@Ƀf[^ǂݍ
	ReadBinFile(nOffset);

	// sxǂݏoobt@NA
	memset(m_aPrevNextBuf, 0, sizeof(m_aPrevNextBuf));
	m_bPrevNext = FALSE;
}

//*****************************************************************************************************
//  1. ֐
//		CRealtimeBinData::GetBinData
//----------------------------------------------------------------------------------------------------
//  2. @\
//		oCif[^t@CPf[^擾
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		int		擾f[^
//*****************************************************************************************************
int CRealtimeBinData::GetBinData()
{
	// obt@̃f[^ǂݏI玟̃oCit@Cǂ
	if (m_nReadPtr >= m_nBufSize) {
		if (m_nBinFileIndex >= m_aBinFile.GetSize() - 1)
			return 0;

		int nCurrentOffset = m_aBinFile[m_nBinFileIndex].m_nBinDataOffset + m_aBinFile[m_nBinFileIndex].m_nBinDataSize;
		ReadBinFile(nCurrentOffset - m_aBinFile[++m_nBinFileIndex].m_nBinDataOffset);
	}

	int nData;
	if (m_nReadPtr >= 0) {
		// oCit@Cobt@Pf[^荞
		BYTE *p = m_pBinBuf + m_nReadPtr * 3;
		nData = GetAd(p);
	} else {
		// t@Cf[^Ԃ
		nData = LOSS_DATA;
	}
	m_nReadPtr++;

	return nData;
}

// 2010/9/24 modified by y.GOTO for ver.4.02 ->
//*****************************************************************************************************
//  1. ֐
//		CRealtimeBinData::GetBinDataUnsigned
//----------------------------------------------------------------------------------------------------
//  2. @\
//		oCif[^t@CPf[^擾
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		unsigned int		擾f[^
//*****************************************************************************************************
unsigned int CRealtimeBinData::GetBinDataUnsigned()
{
	// obt@̃f[^ǂݏI玟̃oCit@Cǂ
	if (m_nReadPtr >= m_nBufSize) {
		if (m_nBinFileIndex >= m_aBinFile.GetSize() - 1)
			return 0;

		int nCurrentOffset = m_aBinFile[m_nBinFileIndex].m_nBinDataOffset + m_aBinFile[m_nBinFileIndex].m_nBinDataSize;
		ReadBinFile(nCurrentOffset - m_aBinFile[++m_nBinFileIndex].m_nBinDataOffset);
	}

	unsigned int nData;
	if (m_nReadPtr >= 0) {
		// oCit@Cobt@Pf[^荞
		BYTE *p = m_pBinBuf + m_nReadPtr * 3;
		nData = GetAd(p);
	} else {
		// t@Cf[^Ԃ
		nData = LOSS_DATA;
	}
	m_nReadPtr++;

	return nData;
}
// <- 2010/9/24 modified by y.GOTO for ver.4.02

//*****************************************************************************************************
//  1. ֐
//		CRealtimeBinData::GetAccelData
//----------------------------------------------------------------------------------------------------
//  2. @\
//		oCif[^t@Cxf[^擾
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		int		擾f[^
//*****************************************************************************************************
int CRealtimeBinData::GetAccelData()
{
	// ͐sxǂݏoobt@ɂQf[^ǂݍ
	if (!m_bPrevNext) {
		m_bPrevNext = TRUE;
		m_aPrevNextBuf[1] = GetBinData();
		m_aPrevNextBuf[0] = GetBinData();
	}

	// oCit@Cobt@Pf[^荞
	int nData = GetBinData();

	// sxǂݏoobt@ɃZbg
	memmove(m_aPrevNextBuf + 1, m_aPrevNextBuf, sizeof(m_aPrevNextBuf) - sizeof(m_aPrevNextBuf[0]));
	m_aPrevNextBuf[0] = nData;

	return m_aPrevNextBuf[2];
}

//*****************************************************************************************************
//  1. ֐
//		CRealtimeBinData::GetTempData
//----------------------------------------------------------------------------------------------------
//  2. @\
//		oCif[^t@C牷xf[^擾
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		int		nOffset			[I] f[^Ŝ̃ItZbgʒu
//		int		&tdacm			[O] 擾tdacmf[^ -> unsigned intɕύX(ver.4.02)
//		int		&tx				[O] 擾txf[^
//		int		&ty				[O] 擾tyf[^
//		int		&tz				[O] 擾tzf[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
//void CRealtimeBinData::GetTempData(int nOffset, int &tdacm, int &tx, int &ty, int &tz)		// 2010/9/24 modified by y.GOTO for ver.4.02
void CRealtimeBinData::GetTempData(int nOffset, unsigned int &tdacm, int &tx, int &ty, int &tz)	// 2010/9/24 modified by y.GOTO for ver.4.02
{
	// 40f[^Ƀf[^ǂ
	if (nOffset % 40 == 0) {
		m_aTempData[0] = GetBinDataUnsigned();
		m_aTempData[1] = GetBinData();
		m_aTempData[2] = GetBinData();
		m_aTempData[3] = GetBinData();
	}

	// oCit@Cobt@牷xf[^荞
	tdacm = m_aTempData[0];
	tx = m_aTempData[1];
	ty = m_aTempData[2];
	tz = m_aTempData[3];
}

//*****************************************************************************************************
//  1. ֐
//		CRealtimeBinData::ReadBinFile
//----------------------------------------------------------------------------------------------------
//  2. @\
//		oCif[^t@Cobt@Ƀf[^ǂݍ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		int		nOffset			[I] f[^̃ItZbgʒu
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CRealtimeBinData::ReadBinFile(int nOffset)
{
	// oCit@Cobt@
	FreeBuf();

	// ǂݏo|C^ݒ
	m_nReadPtr = min(nOffset, 0);
	int nReadOffset = max(nOffset, 0);

	// oCit@Cobt@m
	m_nBufSize = m_aBinFile[m_nBinFileIndex].m_nBinDataSize - nReadOffset;
	m_pBinBuf = new BYTE[m_nBufSize * 3];

	// oCit@CI[v
	CFile oBinFile;
	int nRetry = 0;
	while (true) {
		if (!oBinFile.Open(m_aBinFile[m_nBinFileIndex].m_sPathName, CFile::modeRead | CFile::shareDenyNone)) {
			if (++nRetry == 120) {
				CGeneral::Alert("A^CpoCit@CJ܂B(%s)", m_aBinFile[m_nBinFileIndex].m_sPathName);
				throw new CUserException;
			}
			::Sleep(500);
		} else
			break;
	}

	// oCit@Cobt@Ƀf[^ǂݍށiPf[^͂RoCgj
	oBinFile.Seek(BIN_HEADER_SIZE + nReadOffset * 3, CFile::begin);
	oBinFile.Read(m_pBinBuf, m_nBufSize * 3);
}

//*****************************************************************************************************
//  1. ֐
//		CRealtimeGraph::CRealtimeGraph
//----------------------------------------------------------------------------------------------------
//  2. @\
//		A^COtNX̃RXgN^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
CRealtimeGraph::CRealtimeGraph()
{
	m_pGraphAccl = NULL;
	m_pGraphTemp = NULL;
	m_nIdbSize = 0;
	m_bUpdateGraph = FALSE;
	m_bExistLossFile = FALSE;
	m_nStartOffset = -1;
}

//*****************************************************************************************************
//  1. ֐
//		CRealtimeGraph::~CRealtimeGraph
//----------------------------------------------------------------------------------------------------
//  2. @\
//		A^COtNX̃fXgN^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
CRealtimeGraph::~CRealtimeGraph()
{
	if (m_pGraphAccl != NULL)
		m_pGraphAccl->DestroyWindow();

	if (m_pGraphTemp != NULL)
		m_pGraphTemp->DestroyWindow();
}

//*****************************************************************************************************
//  1. ֐
//		CRealtimeGraph::GetIdbName
//----------------------------------------------------------------------------------------------------
//  2. @\
//		idbt@C̃t@C擾
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		CString		idbt@C̃t@C
//*****************************************************************************************************
CString CRealtimeGraph::GetIdbName()
{
	CString sIdbName;
	sIdbName.Format("%04d%04d%02d%02d%d", m_nRsuId, m_dtStartTime.m_YY, m_dtStartTime.m_MM, m_dtStartTime.m_DD, ((m_dtStartTime.m_hh * 60 + m_dtStartTime.m_mm) * 60 + m_dtStartTime.m_ss) * 1000 + m_dtStartTime.m_ttt);
	return sIdbName;
}

//*****************************************************************************************************
//  1. ֐
//		CRealtimeGraph::GetIdbPathName
//----------------------------------------------------------------------------------------------------
//  2. @\
//		idbt@C̃pX擾
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		CString		idbt@C̃pX
//*****************************************************************************************************
CString CRealtimeGraph::GetIdbPathName()
{
	CString sPathName;
	sPathName.Format("%s\\%s.idb", gRealtimeTempPath, GetIdbName());
	return sPathName;
}

//*****************************************************************************************************
//  1. ֐
//		CRealtimeGraph::GetBinDataSize
//----------------------------------------------------------------------------------------------------
//  2. @\
//		xAXYZf[^̍ŏTCY擾
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		int		ŏTCY
//*****************************************************************************************************
int CRealtimeGraph::GetBinDataSize()
{
	// xAXYZ̃f[^ŏTCY擾
	int nDataSize = m_aBinData[0].GetBinDataSize() * 10;
	for (int i = 1; i < 4; i++) {
		if (m_aBinData[i].GetBinDataSize() < nDataSize)
			nDataSize = m_aBinData[i].GetBinDataSize();
	}

	return nDataSize / 40 * 40;		// xf[^̋؂TCYƂ
}

//*****************************************************************************************************
//  1. ֐
//		CRealtimeGraph::MakeIdbFile
//----------------------------------------------------------------------------------------------------
//  2. @\
//		idbt@CyэHwlϊς݃t@C쐬
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CRealtimeGraph::MakeIdbFile()
{
	if (GetBinDataSize() > 0) {
		if (m_nStartOffset == -1) {
			m_nStartOffset = m_aBinData[0].m_aBinFile[0].m_nBinDataOffset * 10;
			for (int i = 1; i < 4; i++) {
				if (m_aBinData[i].m_aBinFile[0].m_nBinDataOffset > m_nStartOffset)
					m_nStartOffset = m_aBinData[i].m_aBinFile[0].m_nBinDataOffset;
			}
			m_nStartOffset = (m_nStartOffset + 40 - 1) / 40 * 40;
			m_dtStartTime += (long)(m_nStartOffset / m_aBinData[1].m_aBinFile[0].m_fSampleRate) * 1000;
		}

		// idbt@C擾
		CString sIdbPathName = GetIdbPathName();

		// idbt@C݂邩`FbN
		if (::PathFileExists(sIdbPathName)) {
			// ݂ꍇ͏ǂݍ
			CDataFile oDataFile;
			if (!oDataFile.ReadInfoFile(sIdbPathName))
				throw new CUserException;
			m_nIdbSize = m_nStartOffset + oDataFile.m_nTotalDataSize;
		} else
			m_nIdbSize = m_nStartOffset;

		// oCif[^TCYHwlϊς݃f[^傫Βǉꂽf[^Hwlϊ
		if (GetBinDataSize() > m_nIdbSize) {
			CIdbFile oIdbFile;

			if (m_nIdbSize != 0) {
				// idbt@C݂ꍇ͂ǂݍ
				oIdbFile.Read2(GetIdbPathName());
			}

			// idbt@C擾
			CBinFile oBinFile;
			if (oBinFile.OpenBin(m_aBinData[1].m_aBinFile[0].m_sPathName, TRUE)) {
				oBinFile.ReadHeader();
				oBinFile.CloseBin();

				double fSampleRate = 10e6 / (512 * oBinFile.m_SampleRate);
				oIdbFile.SetSampleRate(fSampleRate);
				oIdbFile.SetPath(gRealtimeTempPath);
				oIdbFile.SetGain((int)(pow(2.0, (double)(oBinFile.m_CalGain & 0x0f))));
				oIdbFile.SetCutoff(oBinFile.m_CutOff);
				oIdbFile.SetStartTime(m_dtStartTime.m_YY, m_dtStartTime.m_MM, m_dtStartTime.m_DD, ((m_dtStartTime.m_hh * 60 + m_dtStartTime.m_mm) * 60 + m_dtStartTime.m_ss) * 1000 + m_dtStartTime.m_ttt);
				oIdbFile.SetRsuId(m_nRsuId);
				oIdbFile.SetNetworkid(0);
				oIdbFile.SetSensorId(m_nTaaId);
				oIdbFile.SetSensorIdx(-1);

				m_nCntPerHour = (int)(fSampleRate * 3600);
				m_nCutOff = oBinFile.m_CutOff;
				m_nOffset = oBinFile.m_Offset;
			}

			// Hwlϊs
			ConvertFile(oIdbFile);

			// idbt@Cɏ
			oIdbFile.Write(GetIdbName());

			// OtXVtOZbg
			m_bUpdateGraph = TRUE;
		}
	}
}

//*****************************************************************************************************
//  1. ֐
//		CRealtimeGraph::ConvertFile
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Hwlϊς݃t@C쐬
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CIdbFile	&oIdbFile			[I] idbt@CNX
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CRealtimeGraph::ConvertFile(CIdbFile &oIdbFile)
{
	int i;
	ST_AD ad;
	ST_CALC_DATA calc;
	CFile oFileCalc;
	INFO_FILE_HEADER sHeader;
	CString sPathName;
	CDataDateTime oTime;

	// vZp[^ݒ
	CCalcFile oCalcFile;
	if (!oCalcFile.SetArg(m_nRsuId, m_nTaaId, m_nCntPerHour, m_nOffset, m_nCutOff)) {
		CGeneral::Alert("Hwlϊp萔e[uɕs܂B");
		throw new CUserException;
	}

	// Hwlϊς݃t@CI[v
	if (oIdbFile.m_File.GetSize() != 0) {
		sPathName.Format("%s\\%s", gRealtimeTempPath, oIdbFile.m_File[oIdbFile.m_File.GetSize() - 1]);
		if (!oFileCalc.Open(sPathName, CFile::modeReadWrite | CFile::shareDenyNone)) {
			CGeneral::Alert("A^CpHwlϊς݃t@CJ܂B(%s)", sPathName);
			throw new CUserException;
		}
		oFileCalc.Read(&sHeader, sizeof(sHeader));
		oFileCalc.Seek(sHeader.nDataSize * sizeof(double) * 7, CFile::current);
	} else {
		memset(&sHeader, 0, sizeof(sHeader));
	}

	// BINt@CV[N
	m_aBinData[0].SeekBinFile(m_nIdbSize / 40 * 4);
	for (i = 1; i < 4; i++)
		m_aBinData[i].SeekBinFile(m_nIdbSize);

	// Hwlϊ
	int nDataSize = GetBinDataSize();
	while (m_nIdbSize < nDataSize) {
		// oCit@C牷xf[^Axf[^o
		m_aBinData[0].GetTempData(m_nIdbSize, ad.tdacm, ad.tx, ad.ty, ad.tz);
		ad.x = m_aBinData[1].GetAccelData();
		ad.y = m_aBinData[2].GetAccelData();
		ad.z = m_aBinData[3].GetAccelData();

		// G[l̏u
		if (ad.x == 0x800000)
			ad.x = oCalcFile.AdjustForNegativeFullscale(ad.x, m_aBinData[1].m_aPrevNextBuf[4], m_aBinData[1].m_aPrevNextBuf[3], m_aBinData[1].m_aPrevNextBuf[1], m_aBinData[1].m_aPrevNextBuf[0]);
		if (ad.y == 0x800000)
			ad.y = oCalcFile.AdjustForNegativeFullscale(ad.y, m_aBinData[2].m_aPrevNextBuf[4], m_aBinData[2].m_aPrevNextBuf[3], m_aBinData[2].m_aPrevNextBuf[1], m_aBinData[2].m_aPrevNextBuf[0]);
		if (ad.z == 0x800000)
			ad.z = oCalcFile.AdjustForNegativeFullscale(ad.z, m_aBinData[3].m_aPrevNextBuf[4], m_aBinData[3].m_aPrevNextBuf[3], m_aBinData[3].m_aPrevNextBuf[1], m_aBinData[3].m_aPrevNextBuf[0]);

		// Hwlϊ̌vZs
		oCalcFile.CalcData(&ad, &calc);

		// t@C̍Hwϊl0ɂ
		if (ad.x == LOSS_DATA || ad.tx == LOSS_DATA || ad.tdacm == LOSS_DATA) {
			calc.x = 0;
			calc.tx = 0;
			calc.dacm = 0;
			m_bExistLossFile = TRUE;
		}
		if (ad.y == LOSS_DATA || ad.ty == LOSS_DATA || ad.tdacm == LOSS_DATA) {
			calc.y = 0;
			calc.ty = 0;
			calc.dacm = 0;
			m_bExistLossFile = TRUE;
		}
		if (ad.z == LOSS_DATA || ad.tz == LOSS_DATA || ad.tdacm == LOSS_DATA) {
			calc.z = 0;
			calc.tz = 0;
			calc.dacm = 0;
			m_bExistLossFile = TRUE;
		}

		// Hwlϊς݃t@C͂PԖɕ
		if (sHeader.nDataSize == sHeader.nDataSizeHour) {
			// Pԕ񂾂wb_ăN[Y
			if (oFileCalc.m_hFile != CFile::hFileNull) {
				oFileCalc.Seek(0, CFile::begin);
				oFileCalc.Write(&sHeader, sizeof(sHeader));
				oFileCalc.Close();
			}

			// wb_̏
			sHeader.nSeqNo = (int)oIdbFile.m_File.GetSize() + 1;
			sHeader.nDataSize = 0;
			sHeader.nDataSizeHour = m_nCntPerHour;

			// idbt@CɎ̍Hwlϊς݃t@Co^
			CString sFileName;
			oTime = m_dtStartTime + 3600000 * (int)oIdbFile.m_File.GetSize();
			sFileName.Format("%04d_%02d_%02d_%02d_%02d_%02d.%03d.%04x"
				, oTime.m_YY
				, oTime.m_MM
				, oTime.m_DD
				, oTime.m_hh
				, oTime.m_mm
				, oTime.m_ss
				, oTime.m_ttt
				, m_nTaaId);
			oIdbFile.m_File.Add(sFileName);

			// Hwlϊς݃t@CVK쐬
			sPathName.Format("%s\\%s", gRealtimeTempPath, sFileName);
			if (!oFileCalc.Open(sPathName, CFile::modeCreate | CFile::modeWrite | CFile::shareDenyNone)) {
				CGeneral::Alert("A^CpHwlϊς݃t@CJ܂B(%s)", sPathName);
				throw new CUserException;
			}
			oFileCalc.Write(&sHeader, sizeof(sHeader));
		}

		// Hwlϊς݃t@CɃf[^
		oFileCalc.Write(&calc, sizeof(calc));

		// f[^TCYXV
		sHeader.nDataSize++;
		m_nIdbSize++;
	}

	// wb_
	oFileCalc.Seek(0, CFile::begin);
	oFileCalc.Write(&sHeader, sizeof(sHeader));

	// oCit@Cǂݍ݃obt@
	for (i = 0; i < 4; i++)
		m_aBinData[i].FreeBuf();
}

//*****************************************************************************************************
//  1. ֐
//		CRealtimeData::CRealtimeData
//----------------------------------------------------------------------------------------------------
//  2. @\
//		A^Cf[^NX̃RXgN^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
CRealtimeData::CRealtimeData()
{
	m_bStartFlag = FALSE;
	m_bStopFlag = FALSE;
	m_bLoop = TRUE;

	// [JXbhN
	m_hThread = AfxBeginThread(RealtimeDataThreadEntry, this, THREAD_PRIORITY_BELOW_NORMAL)->m_hThread;
}

//*****************************************************************************************************
//  1. ֐
//		CRealtimeData::~CRealtimeData
//----------------------------------------------------------------------------------------------------
//  2. @\
//		A^Cf[^NX̃fXgN^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
CRealtimeData::~CRealtimeData()
{
	// [JXbh̃[vI
	m_bLoop = FALSE;

	// [JXbhXbh̏I҂
	m_oEvent.PulseEvent();
	::WaitForSingleObject(m_hThread, 1000);

	// e|tH_̃t@C폜
	DeleteTempFiles();
}

//*****************************************************************************************************
//  1. ֐
//		CRealtimeData::Start
//----------------------------------------------------------------------------------------------------
//  2. @\
//		A^C\Jn
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CRealtimeData::Start()
{
	// RSU_ID-TAA_IDΉe[uǂݍ
	if (!g_RsuTaaTbl.SetTbl()) {
		AfxMessageBox("RSU_ID-TAA_IDΉe[u܂B", MB_OK | MB_ICONEXCLAMATION);
		return;
	}

	// bint@Cړ
	MoveOldBinData();

	// ̃A^Cʂ
	m_aGraph.RemoveAll();

	// [JXbhŃA^CJn
	m_bStartFlag = TRUE;
	m_bStopFlag = FALSE;
	m_oEvent.PulseEvent();
}

//*****************************************************************************************************
//  1. ֐
//		CRealtimeData::Stop
//----------------------------------------------------------------------------------------------------
//  2. @\
//		A^C\~
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CRealtimeData::Stop()
{
	// [JXbh̃A^C~
	m_bStartFlag = FALSE;
	m_bStopFlag = TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CRealtimeData::RealtimeDataThreadEntry
//----------------------------------------------------------------------------------------------------
//  2. @\
//		A^CXbh̓
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPVOID			pParam			[I] CDataFileNXւ̃|C^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		UINT	0
//*****************************************************************************************************
UINT CRealtimeData::RealtimeDataThreadEntry(LPVOID pParam)
{
	((CRealtimeData *)pParam)->RealtimeDataThread();

	return 0;
}

//*****************************************************************************************************
//  1. ֐
//		CRealtimeData::RealtimeDataThread
//----------------------------------------------------------------------------------------------------
//  2. @\
//		A^CXbh̖{
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CRealtimeData::RealtimeDataThread()
{
	while (m_bLoop) {
		// ҂
		m_oEvent.Lock(CYCLE_TIME);

		if (m_bStartFlag) {
			try {
				// oCit@C̏ǂݍ
				GetBinFileInfo();

				// idbt@CyэHwlϊς݃t@C쐬
				for (int i = 0; i < m_aGraph.GetSize(); i++)
					m_aGraph[i].MakeIdbFile();

				// OtEBhE̓CXbhŊJ
				CWnd *pMainWnd = theApp.m_pMainWnd;
				if (pMainWnd->GetSafeHwnd() != NULL)
					pMainWnd->SendMessage(WM_USER_REALTIME_GRAPH);
			} catch (CUserException *e) {
				// G[ꍇ̓A^C\~iŉx\̂邽߁j
				m_bStartFlag = FALSE;
				e->Delete();
			}
		}

		if (m_bStopFlag) {
			DeleteTempFiles();
			m_bStopFlag = FALSE;
		}
	}
}

//*****************************************************************************************************
//  1. ֐
//		CRealtimeData::GetBinFileInfo
//----------------------------------------------------------------------------------------------------
//  2. @\
//		oCit@C̏擾
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CRealtimeData::GetBinFileInfo()
{
	CFileFind FileFind;

	// A^Cf[^tH_̃t@C
	CString sSearchFile;
	sSearchFile.Format("%s\\*.bin", gRealtimeDataPath);
	if (!FileFind.FindFile(sSearchFile)) 
		return; 

	// ꂽoCit@C
	BOOL bContinue = TRUE;
	while (bContinue) { 
		bContinue = FileFind.FindNextFile();

		// ꂽoCit@Czɒǉ
		AddBinFile(FileFind.GetFileName(), FileFind.GetFilePath());
	}
}

//*****************************************************************************************************
//  1. ֐
//		CRealtimeData::AddBinFile
//----------------------------------------------------------------------------------------------------
//  2. @\
//		oCit@C̏zɐݒ肷
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CString		&sBinFileName			[I] oCit@C̃t@C
//		CString		&sBinPathName			[I] oCit@C̃pX
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CRealtimeData::AddBinFile(const CString &sBinFileName, const CString &sBinPathName)
{
	int i, j;

	// BINt@C𕪉
	CStringArray saFileNameParts;
	CGeneral::StrSplit(sBinFileName, "-.", saFileNameParts);
	if (saFileNameParts.GetSize() < 5)
		return;

	// BINt@C烆jbgԍƎʔԍ擾
	int nRsuId = atoi(saFileNameParts[0]);
	int nKind = atoi(saFileNameParts[1]);
	CString sStartDateTime = saFileNameParts[2] + saFileNameParts[3];
	int nBinDataOffset = atoi(saFileNameParts[4]);
	if (nKind < 0 || nKind > 3)
		return;

	// BINt@C̃wb_擾
	CBinFile oBinFile;
	if (!oBinFile.OpenBin(sBinPathName, TRUE))
		return;
	oBinFile.ReadHeader();

	// BINt@Czɒǉ
	for (i = 0; i < m_aGraph.GetSize(); i++) {
		if (m_aGraph[i].m_nRsuId == nRsuId && m_aGraph[i].m_sStartDateTime == sStartDateTime)
			break;
	}
	if (i == m_aGraph.GetSize()) {
		// RSU IDTAA ID߂
		int nTaaId = g_RsuTaaTbl.GetTaaId(nRsuId);
		if (nTaaId == -1) {
			CGeneral::Alert("A^Cf[^RSU_IDRSU_ID-TAA_IDΉe[uɑ݂܂B\n(RSU_ID=%d)", nRsuId);
			throw new CUserException;
		}

		// A^COtf[^쐬
		CRealtimeGraph oRealtimeGraph;
		oRealtimeGraph.m_nRsuId = nRsuId;
		oRealtimeGraph.m_nTaaId = g_RsuTaaTbl.GetTaaId(nRsuId);
		oRealtimeGraph.m_sStartDateTime = sStartDateTime;

		// v𕪉
		CStringArray saFileNameParts;
		CGeneral::StrSplit(sStartDateTime, "_", saFileNameParts);
		oRealtimeGraph.m_dtStartTime.SetTime(atoi(saFileNameParts[0]), atoi(saFileNameParts[1]), atoi(saFileNameParts[2]), atoi(saFileNameParts[3]), atoi(saFileNameParts[4]), atoi(saFileNameParts[5]), atoi(saFileNameParts[6]));

		// A^COtzɒǉ
		m_aGraph.Add(oRealtimeGraph);
	}

	// oCit@Ct@CɔzɃZbg
	CRealtimeGraph &oRealtimeGraph = m_aGraph[i];
	CRealtimeBinData &oRealtimeBinData = oRealtimeGraph.m_aBinData[nKind];
	for (j = 0; j < oRealtimeBinData.m_aBinFile.GetSize(); j++) {
		if (oRealtimeBinData.m_aBinFile[j].m_nBinDataOffset >= nBinDataOffset)
			break;
	}
	if (j < oRealtimeBinData.m_aBinFile.GetSize() && oRealtimeBinData.m_aBinFile[j].m_nBinDataOffset == nBinDataOffset) {
		oRealtimeBinData.m_aBinFile[j].m_nBinDataSize = oBinFile.m_Size;
	} else {
		CRealtimeBinFile oRealtimeBinFile;
		oRealtimeBinFile.m_sPathName = sBinPathName;
		oRealtimeBinFile.m_nBinDataOffset = nBinDataOffset;
		oRealtimeBinFile.m_nBinDataSize = oBinFile.m_Size;
		oRealtimeBinFile.m_fSampleRate = 10e6 / (512 * oBinFile.m_SampleRate);
		oRealtimeBinData.m_aBinFile.InsertAt(j, oRealtimeBinFile);
	}
}

//*****************************************************************************************************
//  1. ֐
//		CRealtimeData::UpdateGraphWindow
//----------------------------------------------------------------------------------------------------
//  2. @\
//		A^Cf[^EBhE\
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CRealtimeData::UpdateGraphWindow()
{
	for (int i = 0; i < m_aGraph.GetSize(); i++) {
		CRealtimeGraph &oGraph = m_aGraph[i];

		if (oGraph.m_nIdbSize > 0) {
			// xOt
			if (oGraph.m_pGraphTemp == NULL) {
				// A^COtʂ\ĂȂꍇ͐VKɃEBhEJ
				CGraphFrame *pGraphFrame = new CGraphFrame;
				if (pGraphFrame->DispRealtimeGraph(oGraph.GetIdbPathName(), GRAPH_TEMP, oGraph.m_bExistLossFile))
					oGraph.m_pGraphTemp = pGraphFrame;
				else {
					delete pGraphFrame;
					m_aGraph.RemoveAt(i);
				}
			} else if (oGraph.m_bUpdateGraph) {
				// A^COtʂ\ĂčXVꍇ̓Otɔf
				oGraph.m_pGraphTemp->UpdateRealtimeGraph(oGraph.m_bExistLossFile);
			}

			// xOt
			if (oGraph.m_pGraphAccl == NULL) {
				// A^COtʂ\ĂȂꍇ͐VKɃEBhEJ
				CGraphFrame *pGraphFrame = new CGraphFrame;
				if (pGraphFrame->DispRealtimeGraph(oGraph.GetIdbPathName(), GRAPH_ACCEL, oGraph.m_bExistLossFile))
					oGraph.m_pGraphAccl = pGraphFrame;
				else {
					delete pGraphFrame;
					m_aGraph.RemoveAt(i);
				}
			} else if (oGraph.m_bUpdateGraph) {
				// A^COtʂ\ĂčXVꍇ̓Otɔf
				oGraph.m_pGraphAccl->UpdateRealtimeGraph(oGraph.m_bExistLossFile);
			}
		}

		oGraph.m_bUpdateGraph = FALSE;
	}
}

//*****************************************************************************************************
//  1. ֐
//		CRealtimeData::CloseGraphWindow
//----------------------------------------------------------------------------------------------------
//  2. @\
//		A^Cf[^EBhE蓮ŃN[Yꂽ̏
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		HWND		hWnd			[I] N[YEBhẼnh
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CRealtimeData::CloseGraphWindow(HWND hWnd)
{
	// OtEBhE蓮ŃN[Yꍇ͂̃|C^NA
	for (int i = 0; i < m_aGraph.GetSize(); i++) {
		CRealtimeGraph &oGraph = m_aGraph[i];
		if (oGraph.m_pGraphAccl != NULL) {
			if (oGraph.m_pGraphAccl->m_hWnd == hWnd) {
				oGraph.m_pGraphAccl = NULL;
				break;
			}
		}
		if (oGraph.m_pGraphTemp != NULL) {
			if (oGraph.m_pGraphTemp->m_hWnd == hWnd) {
				oGraph.m_pGraphTemp = NULL;
				break;
			}
		}
	}
}

//*****************************************************************************************************
//  1. ֐
//		CRealtimeData::DeleteTempFiles
//----------------------------------------------------------------------------------------------------
//  2. @\
//		e|t@C폜
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CRealtimeData::DeleteTempFiles()
{
	if (gRealtimeTempPath[0] != '\n') {
		CFileFind FileFind;

		// e|tH_idbt@C
		CString sSearchFile;
		sSearchFile.Format("%s\\*.idb", gRealtimeTempPath);
		if(!FileFind.FindFile(sSearchFile)) 
			return; 

		// ꂽidbt@C
		BOOL bContinue = TRUE;
		while(bContinue){ 
			bContinue = FileFind.FindNextFile();

			// ꂽidbt@C폜
			DeleteIdbFile(FileFind.GetFilePath());
		}
	}
}

//*****************************************************************************************************
//  1. ֐
//		CRealtimeData::DeleteIdbFile
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Idbt@C폜
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPCTSTR		pIdbFilePath			[I] idbt@CpX
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CRealtimeData::DeleteIdbFile(LPCTSTR pIdbFilePath)
{
	CDataFile oDataFile;
	if (oDataFile.ReadInfoFile(pIdbFilePath)) {
		CString sDatPath;
		for (int i = 0; i < oDataFile.m_aDataFileName.GetSize(); i++) {
			// f[^t@C폜
			sDatPath.Format("%s\\%s", oDataFile.m_sDatPath, oDataFile.m_aDataFileName[i]);
			::DeleteFile(sDatPath);
		}
	}

	// idbt@C폜
	::DeleteFile(pIdbFilePath);
}

//*****************************************************************************************************
//  1. ֐
//		CRealtimeData::UpdateTempGraph
//----------------------------------------------------------------------------------------------------
//  2. @\
//		xOtXV
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CGraphFrame		*pGraphAccl			[I] xOt
//		double			fTimeDispEnd		[I] \͈
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CRealtimeData::UpdateTempGraph(CGraphFrame *pGraphAccl, double fTimeDispEnd)
{
	for (int i = 0; i < m_aGraph.GetSize(); i++) {
		CRealtimeGraph &oGraph = m_aGraph[i];
		if (oGraph.m_pGraphAccl == pGraphAccl) {
			if (oGraph.m_pGraphTemp != NULL)
				oGraph.m_pGraphTemp->SetRealtimeDispEnd(fTimeDispEnd);
		}
	}
}

//*****************************************************************************************************
//  1. ֐
//		CRealtimeData::MoveOldBinData
//----------------------------------------------------------------------------------------------------
//  2. @\
//		A^CJnɊɑ݂bint@Cړ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CRealtimeData::MoveOldBinData()
{
	CString sOldBinFolder;
	sOldBinFolder.Format("%s\\%s", gRealtimeTempPath, OLD_BIN_FILE);

	// ړtH_쐬
	if (!::PathIsDirectory(sOldBinFolder))
		::CreateDirectory(sOldBinFolder, NULL);

	// bint@Cړ
	CFileStatus fs;
	CString sFindFile;
	CString sMovePath;
	sFindFile.Format("%s\\*", gRealtimeDataPath);
	CFileFind oFileFind;
	BOOL bFind = oFileFind.FindFile(sFindFile);
	while (bFind) {
		bFind = oFileFind.FindNextFile();

		CFile::GetStatus(oFileFind.GetFilePath(), fs);
		if (!(fs.m_attribute & CFile::directory)) {
			sMovePath.Format("%s\\%s", sOldBinFolder, oFileFind.GetFileName());
			if (::PathFileExists(sMovePath))
				::DeleteFile(sMovePath);

			::MoveFile(oFileFind.GetFilePath(), sMovePath);
		}
	}
}
